#ifndef EXPALGNDISTNEW_H
#define EXPALGNDISTNEW_H
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cassert>
#include<cmath>
#include<string>
#include<stdint.h>
#include<limits>
#include<map>
#include<vector>
#include<sstream>
#include<time.h>
#include<algorithm>
#include<iterator>
#include<stdlib.h> 
#include "quadmath.h"
#include "misc.h"
#include "SubmatClass.h"
#include "nullModelClass.h"
#include "dpcellClass.h"
using namespace std;

#define NLTOTM(R, C) (dpmat[0][(R)][(C)].neglogTotPr)
#define NLTOTD(R, C) (dpmat[1][(R)][(C)].neglogTotPr)
#define NLTOTI(R, C) (dpmat[2][(R)][(C)].neglogTotPr)

#define NLEADM(R, C) (nlead[0][(R)][(C)])
#define NLEADD(R, C) (nlead[1][(R)][(C)])
#define NLEADI(R, C) (nlead[2][(R)][(C)])

double expectedAlignmentDistance_formal(string, string, nullModelClass_t &,
                SubmatClass_t &, vector<string> &, vector<vector<vector<dpcell_t> > >
                &, int);

vector<int> computeDiagsFromAlgn(vector<string> &);

vector<vector<int> > computeCellPathFromAlgn(vector<string> &);

double DPExpAlgnDist(string &,string &,nullModelClass_t &,SubmatClass_t &,
                        int, vector<vector<vector<dpcell_t> > > &, vector<int> &);

double NLSE_w_factors(vector<pair<double,double> >);

double expectedAlignmentDistance_sampled(string,string,vector<string> &, vector<vector<vector<dpcell_t> > > &,int);

vector<string>  sampleAlignment(string,string,vector<vector<vector<dpcell_t> > > &); 

double computeTwoAlgnDist(vector<int> &, vector<int> &);

#endif
